From ad4002262c19e81390f518a14f99bb594862c575 Mon Sep 17 00:00:00 2001
From: "YoungJoo.Kim" <vozltx@gmail.com>
Date: Tue, 26 Jun 2018 16:55:11 +0900
Subject: [PATCH] Compatibility: fixed
 ngx_http_vhost_traffic_status_display_get_upstream_nelts() to calculate all A
 records of server.

---
 README.md                                   |  2 +-
 src/ngx_http_vhost_traffic_status_display.c | 14 +++++++++-----
 2 files changed, 10 insertions(+), 6 deletions(-)

diff --git a/README.md b/README.md
index 0ff43cc..f10f7d0 100644
--- a/README.md
+++ b/README.md
@@ -1697,7 +1697,7 @@ For examples:
 `Description:` Sets the method which is a formula that calculate the average of response processing times.
 The *period* is an effective time of the values used for the average calculation.(Default: 60s)
 If *period* set to 0, effective time is ignored.
-In this case, the last average value is displayed even if there is no reqeusts and after the elapse of time.
+In this case, the last average value is displayed even if there is no requests and after the elapse of time.
 The corresponding values are `requestMsec` and `responseMsec` in JSON.
 
 * **AMM**
diff --git a/src/ngx_http_vhost_traffic_status_display.c b/src/ngx_http_vhost_traffic_status_display.c
index 623231f..c0d106a 100644
--- a/src/ngx_http_vhost_traffic_status_display.c
+++ b/src/ngx_http_vhost_traffic_status_display.c
@@ -452,7 +452,8 @@ ngx_http_vhost_traffic_status_display_handler_default(ngx_http_request_t *r)
 ngx_int_t
 ngx_http_vhost_traffic_status_display_get_upstream_nelts(ngx_http_request_t *r)
 {
-    ngx_uint_t                      i, j;
+    ngx_uint_t                      i, j, n;
+    ngx_http_upstream_server_t     *us;
 #if (NGX_HTTP_UPSTREAM_ZONE)
     ngx_http_upstream_rr_peer_t    *peer;
     ngx_http_upstream_rr_peers_t   *peers;
@@ -463,12 +464,13 @@ ngx_http_vhost_traffic_status_display_get_upstream_nelts(ngx_http_request_t *r)
     umcf = ngx_http_get_module_main_conf(r, ngx_http_upstream_module);
     uscfp = umcf->upstreams.elts;
 
-    for (i = 0, j = 0; i < umcf->upstreams.nelts; i++) {
+    for (i = 0, j = 0, n = 0; i < umcf->upstreams.nelts; i++) {
 
         uscf = uscfp[i];
 
         /* groups */
         if (uscf->servers && !uscf->port) {
+            us = uscf->servers->elts;
 
 #if (NGX_HTTP_UPSTREAM_ZONE)
             if (uscf->shm_zone == NULL) {
@@ -480,7 +482,7 @@ ngx_http_vhost_traffic_status_display_get_upstream_nelts(ngx_http_request_t *r)
             ngx_http_upstream_rr_peers_rlock(peers);
 
             for (peer = peers->peer; peer; peer = peer->next) {
-                j++;
+                n++;
             }
 
             ngx_http_upstream_rr_peers_unlock(peers);
@@ -489,11 +491,13 @@ ngx_http_vhost_traffic_status_display_get_upstream_nelts(ngx_http_request_t *r)
 
 #endif
 
-            j += uscf->servers->nelts;
+            for (j = 0; j < uscf->servers->nelts; j++) {
+                n += us[j].naddrs;
+            }
         }
     }
 
-    return j;
+    return n;
 }
 
 
